#ifndef __AP_ITEM_H__
#define __AP_ITEM_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define AP_TYPE_ITEM ap_item_get_type ()

G_DECLARE_INTERFACE (APItem, ap_item, AP, ITEM, GObject)

struct _APItemInterface
{
    GTypeInterface parent_iface;

    void
    (*set_name) (APItem *self,
                 gchar  *name);

    gchar *
    (*get_name) (APItem *self);

    void
    (*set_description) (APItem *self,
                        gchar  *description);

    gchar *
    (*get_description) (APItem *self);

    void
    (*set_quantity) (APItem  *self,
                     gdouble  quantity);

    gdouble
    (*get_quantity) (APItem *self);

    void
    (*set_weight) (APItem  *self,
                   gdouble  weight);

    gdouble
    (*get_weight) (APItem *self);

    void
    (*set_worth) (APItem  *self,
                  gdouble  worth);

    gdouble
    (*get_worth) (APItem *self);
};

void
ap_item_set_name (APItem *self,
                  gchar  *name);

gchar *
ap_item_get_name (APItem *self);

void
ap_item_set_description (APItem *self,
                         gchar  *description);

gchar *
ap_item_get_description (APItem *self);

void
ap_item_set_quantity (APItem  *self,
                      gdouble  quantity);

gdouble
ap_item_get_quantity (APItem *self);

void
ap_item_set_weight (APItem  *self,
                    gdouble  weight);

gdouble
ap_item_get_weight (APItem *self);

void
ap_item_set_worth (APItem  *self,
                   gdouble  worth);

gdouble
ap_item_get_worth (APItem *self);

G_END_DECLS

#endif /* __AP_ITEM_H__ */

